package de.muenchen.test.impl;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;

import com.sun.star.comp.helper.Bootstrap;
import com.sun.star.comp.loader.FactoryHelper;
import com.sun.star.frame.DispatchDescriptor;
import com.sun.star.frame.XDesktop;
import com.sun.star.frame.XDispatch;
import com.sun.star.frame.XDispatchProvider;
import com.sun.star.lang.XMultiComponentFactory;
import com.sun.star.lang.XMultiServiceFactory;
import com.sun.star.lang.XServiceInfo;
import com.sun.star.lang.XSingleComponentFactory;
import com.sun.star.lang.XSingleServiceFactory;
import com.sun.star.lib.uno.helper.Factory;
import com.sun.star.registry.XRegistryKey;
import com.sun.star.ui.dialogs.XFilePicker;
import com.sun.star.ui.dialogs.XFilePicker;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;
import com.sun.star.beans.XPropertySet;

import de.muenchen.test.XCrashTest;

public class CrashTest extends com.sun.star.lib.uno.helper.WeakBase  implements XServiceInfo, XDispatchProvider, XCrashTest 
{
	
	private static com.sun.star.uno.XComponentContext xComponentContext = null;
	public static XMultiComponentFactory xMCF;
	public static XComponentContext defaultContext;
	public static XMultiServiceFactory xMSF;
	public static XDesktop desktop;
	
	public CrashTest(com.sun.star.uno.XComponentContext xContext) {
		
        this.xComponentContext = xContext;
        
        Object servicemanager = null;
        try 
        {
		    xMCF = (XMultiComponentFactory)UnoRuntime.queryInterface(XMultiComponentFactory.class, xContext.getServiceManager());

    		xMSF = (XMultiServiceFactory)UnoRuntime.queryInterface(XMultiServiceFactory.class, xMCF);
        }
        catch (Exception ex )
        {
        	ex.printStackTrace();
        }
        JFrame lFrame;
        lFrame = new JFrame();
        JButton lButton = new JButton("Choose file ...");
        lButton.addActionListener(new ActionListener(){
        	
        	public void actionPerformed(ActionEvent e){
        		System.out.println("Button pressed");
        		Object o = createUNOService("com.sun.star.ui.dialogs.FilePicker");
        		XFilePicker picker = (XFilePicker)UnoRuntime.queryInterface(XFilePicker.class,o);
        		//XFilePicker picker = UNO.XFilePicker();
        		short res = picker.execute();
        		if (res == com.sun.star.ui.dialogs.ExecutableDialogResults.OK)
        		{
        			 String[] files = picker.getFiles();
   		 	         if (files.length == 0)
   		 	         {
   		 	        	 System.out.println("Keine ausgewählt");
   		 	         }
   		 	         else 
   		 	         {
   		 	        	for (int i = 0; i <   files.length; ++i)
   		 	        	{
   		 	        	System.out.println(files[i]);
   		 	        	}
   		 	         }
   		 	         
        		}
        		JFileChooser lChooser = new JFileChooser();
        		lChooser.show();
        	}
        }); 
        lFrame.getContentPane().add(lButton);
        lFrame.pack();
        lFrame.show();
        
    }

	public static Object createUNOService(String serviceName)
	{
		try{
			
		  //return xMCF.createInstanceWithContext(serviceName, defaultContext);
			return xMCF.createInstanceWithContext(serviceName, xComponentContext);
		}catch(Exception x)
		{
			x.printStackTrace();
			return null;
		}
	}
	
	public static void init(Object remoteServiceManager)
	throws Exception
	{
		System.out.println("init");
		//Object servicemanager = Bootstrap.bootstrap().getServiceManager();
		xMCF = (XMultiComponentFactory)UnoRuntime.queryInterface(XMultiComponentFactory.class, remoteServiceManager);
		xMSF = (XMultiServiceFactory)UnoRuntime.queryInterface(XMultiServiceFactory.class, xMCF);
		defaultContext = (XComponentContext)UnoRuntime.queryInterface(XComponentContext.class,
				((XPropertySet)UnoRuntime.queryInterface(XPropertySet.class,xMCF)).
				getPropertyValue("DefaultContext"));
		
		desktop = (XDesktop)UnoRuntime.queryInterface(XDesktop.class, xMCF.createInstanceWithContext("com.sun.star.frame.Desktop",defaultContext));
		
		/*XBrowseNodeFactory masterBrowseNodeFac = (XBrowseNodeFactory) UnoRuntime.queryInterface(XBrowseNodeFactory.class ,
				defaultContext.getValueByName("/singletons/com.sun.star.script.browse.theBrowseNodeFactory"));
		scriptRoot = new BrowseNode(masterBrowseNodeFac.createView(BrowseNodeFactoryViewTypes.MACROORGANIZER));
		
		XScriptProviderFactory masterProviderFac = (XScriptProviderFactory) UnoRuntime.queryInterface(XScriptProviderFactory.class,
				defaultContext.getValueByName("/singletons/com.sun.star.script.provider.theMasterScriptProviderFactory"));
		masterScriptProvider = masterProviderFac.createScriptProvider(defaultContext);
		
		dbContext = UNO.XNamingService(UNO.createUNOService("com.sun.star.sdb.DatabaseContext"));
		urlTransformer = UNO.XURLTransformer(UNO.createUNOService("com.sun.star.util.URLTransformer"));
        dispatchHelper = UNO.XDispatchHelper(UNO.createUNOService("com.sun.star.frame.DispatchHelper"));*/
	}

	private static final java.lang.String[] SERVICENAMES =
    { "de.muenchen.test.Crashtest" };
	
	  public String[] getSupportedServiceNames()
	  {
	    return SERVICENAMES;
	  }
	  
	  public boolean supportsService(String sService)
	  {
	    int len = SERVICENAMES.length;
	    for (int i = 0; i < len; i++)
	    {
	      if (sService.equals(SERVICENAMES[i])) return true;
	    }
	    return false;
	  }
	  
	  public String getImplementationName()
	  {
	    return (de.muenchen.test.impl.CrashTest.class.getName());
	  }
	  
	  public synchronized static XSingleComponentFactory __getComponentFactory(
	      java.lang.String sImplName)
	  {
	    com.sun.star.lang.XSingleComponentFactory xFactory = null;
	    if (sImplName.equals(de.muenchen.test.impl.CrashTest.class.getName()))
	      xFactory = Factory.createComponentFactory(de.muenchen.test.impl.CrashTest.class, SERVICENAMES);
	    return xFactory;
	  }

	  public synchronized static boolean __writeRegistryServiceInfo(XRegistryKey xRegKey)
	  {
	    return Factory.writeRegistryServiceInfo(de.muenchen.test.impl.CrashTest.class.getName(),
	    		de.muenchen.test.impl.CrashTest.SERVICENAMES, xRegKey);
	  }
	  
	  public synchronized static XSingleServiceFactory __getServiceFactory(String implName,
              XMultiServiceFactory multiFactory,
              com.sun.star.registry.XRegistryKey regKey) {
 
          com.sun.star.lang.XSingleServiceFactory xSingleServiceFactory = null;
          if (implName.equals( de.muenchen.test.impl.CrashTest.class.getName()) )
              xSingleServiceFactory = FactoryHelper.getServiceFactory(
            	de.muenchen.test.impl.CrashTest.class, 
            	de.muenchen.test.impl.CrashTest.SERVICENAMES[0], multiFactory, regKey);
 
          return xSingleServiceFactory;
      }
	  
	  public XDispatch queryDispatch( /* IN */com.sun.star.util.URL aURL,
	  /* IN */String sTargetFrameName,
	  /* IN */int iSearchFlags)
	  {
	    /*return DispatchProviderAndInterceptor.globalWollMuxDispatches.queryDispatch(
	      aURL, sTargetFrameName, iSearchFlags);*/
		  return null;
	  }

	  /*
	   * (non-Javadoc)
	   * 
	   * @seecom.sun.star.frame.XDispatchProvider#queryDispatches(com.sun.star.frame.
	   * DispatchDescriptor[])
	   */
	  public XDispatch[] queryDispatches( /* IN */DispatchDescriptor[] seqDescripts)
	  {
	    /*return DispatchProviderAndInterceptor.globalWollMuxDispatches.queryDispatches(seqDescripts);*/
		  return null;
	  }
	  
	  public void ZifferEinfuegen(){}

}
